"use strict";

Object.defineProperty(exports, "t", {
    value: true
});

class ContainerIterator {
    constructor(t = 0) {
        this.iteratorType = t;
    }
    equals(t) {
        return this.i === t.i;
    }
}

class Base {
    constructor() {
        this.h = 0;
    }
    get length() {
        return this.h;
    }
    size() {
        return this.h;
    }
    empty() {
        return this.h === 0;
    }
}

class Container extends Base {}

function checkObject(t) {
    const e = typeof t;
    return e === "object" && t !== null || e === "function";
}

function throwIteratorAccessError() {
    throw new RangeError("Iterator access denied!");
}

class HashContainerIterator extends ContainerIterator {
    constructor(t, e, s) {
        super(s);
        this.i = t;
        this.o = e;
        if (this.iteratorType === 0) {
            this.pre = function() {
                if (this.i.u === this.o) {
                    throwIteratorAccessError();
                }
                this.i = this.i.u;
                return this;
            };
            this.next = function() {
                if (this.i === this.o) {
                    throwIteratorAccessError();
                }
                this.i = this.i.l;
                return this;
            };
        } else {
            this.pre = function() {
                if (this.i.l === this.o) {
                    throwIteratorAccessError();
                }
                this.i = this.i.l;
                return this;
            };
            this.next = function() {
                if (this.i === this.o) {
                    throwIteratorAccessError();
                }
                this.i = this.i.u;
                return this;
            };
        }
    }
    isAccessible() {
        return this.i !== this.o;
    }
}

class HashContainer extends Container {
    constructor() {
        super();
        this.I = [];
        this._ = {};
        this.HASH_TAG = Symbol("@@HASH_TAG");
        Object.setPrototypeOf(this._, null);
        this.o = {};
        this.o.u = this.o.l = this.H = this.p = this.o;
    }
    S(t) {
        const {u: e, l: s} = t;
        e.l = s;
        s.u = e;
        if (t === this.H) {
            this.H = s;
        }
        if (t === this.p) {
            this.p = e;
        }
        this.h -= 1;
    }
    g(t, e, s) {
        if (s === undefined) s = checkObject(t);
        let i;
        if (s) {
            const s = t[this.HASH_TAG];
            if (s !== undefined) {
                this.I[s].A = e;
                return this.h;
            }
            Object.defineProperty(t, this.HASH_TAG, {
                value: this.I.length,
                configurable: true
            });
            i = {
                j: t,
                A: e,
                u: this.p,
                l: this.o
            };
            this.I.push(i);
        } else {
            const s = this._[t];
            if (s) {
                s.A = e;
                return this.h;
            }
            this._[t] = i = {
                j: t,
                A: e,
                u: this.p,
                l: this.o
            };
        }
        if (this.h === 0) {
            this.H = i;
            this.o.l = i;
        } else {
            this.p.l = i;
        }
        this.p = i;
        this.o.u = i;
        return ++this.h;
    }
    m(t, e) {
        if (e === undefined) e = checkObject(t);
        if (e) {
            const e = t[this.HASH_TAG];
            if (e === undefined) return this.o;
            return this.I[e];
        } else {
            return this._[t] || this.o;
        }
    }
    clear() {
        const t = this.HASH_TAG;
        this.I.forEach((function(e) {
            delete e.j[t];
        }));
        this.I = [];
        this._ = {};
        Object.setPrototypeOf(this._, null);
        this.h = 0;
        this.H = this.p = this.o.u = this.o.l = this.o;
    }
    eraseElementByKey(t, e) {
        let s;
        if (e === undefined) e = checkObject(t);
        if (e) {
            const e = t[this.HASH_TAG];
            if (e === undefined) return false;
            delete t[this.HASH_TAG];
            s = this.I[e];
            delete this.I[e];
        } else {
            s = this._[t];
            if (s === undefined) return false;
            delete this._[t];
        }
        this.S(s);
        return true;
    }
    eraseElementByIterator(t) {
        const e = t.i;
        if (e === this.o) {
            throwIteratorAccessError();
        }
        this.S(e);
        return t.next();
    }
    eraseElementByPos(t) {
        if (t < 0 || t > this.h - 1) {
            throw new RangeError;
        }
        let e = this.H;
        while (t--) {
            e = e.l;
        }
        this.S(e);
        return this.h;
    }
}

class HashSetIterator extends HashContainerIterator {
    constructor(t, e, s, i) {
        super(t, e, i);
        this.container = s;
    }
    get pointer() {
        if (this.i === this.o) {
            throwIteratorAccessError();
        }
        return this.i.j;
    }
    copy() {
        return new HashSetIterator(this.i, this.o, this.container, this.iteratorType);
    }
}

class HashSet extends HashContainer {
    constructor(t = []) {
        super();
        const e = this;
        t.forEach((function(t) {
            e.insert(t);
        }));
    }
    begin() {
        return new HashSetIterator(this.H, this.o, this);
    }
    end() {
        return new HashSetIterator(this.o, this.o, this);
    }
    rBegin() {
        return new HashSetIterator(this.p, this.o, this, 1);
    }
    rEnd() {
        return new HashSetIterator(this.o, this.o, this, 1);
    }
    front() {
        return this.H.j;
    }
    back() {
        return this.p.j;
    }
    insert(t, e) {
        return this.g(t, undefined, e);
    }
    getElementByPos(t) {
        if (t < 0 || t > this.h - 1) {
            throw new RangeError;
        }
        let e = this.H;
        while (t--) {
            e = e.l;
        }
        return e.j;
    }
    find(t, e) {
        const s = this.m(t, e);
        return new HashSetIterator(s, this.o, this);
    }
    forEach(t) {
        let e = 0;
        let s = this.H;
        while (s !== this.o) {
            t(s.j, e++, this);
            s = s.l;
        }
    }
    * [Symbol.iterator]() {
        let t = this.H;
        while (t !== this.o) {
            yield t.j;
            t = t.l;
        }
    }
}

exports.HashSet = HashSet;
//# sourceMappingURL=index.js.map
